Skip to content
PHP Ecosystem
Explore

MultipartFormDataParser

API reference › yii › web › MultipartFormDataParser

classyii\web\MultipartFormDataParser
Extendsyii\base\BaseObject
ImplementsRequestParserInterface, yii\base\Configurable
Since2.0.10
Sourceframework/web/MultipartFormDataParser.php

MultipartFormDataParser parses content encoded as ‘multipart/form-data’.

This parser provides the fallback for the ‘multipart/form-data’ processing on non POST requests, for example: the one with ‘PUT’ request method.

In order to enable this parser you should configure Request::$parsers in the following way:

return [
'components' => [
'request' => [
'parsers' => [
'multipart/form-data' => 'yii\web\MultipartFormDataParser'
],
],
// ...
],
// ...
];

Method parse() of this parser automatically populates $_FILES with the files parsed from raw body.

Note: since this is a request parser, it will initialize $_FILES values on Request::getBodyParams(). Until this method is invoked, $_FILES array will remain empty even if there are submitted files in the request body. Make sure you have requested body params before any attempt to get uploaded file in case you are using this parser.

Usage example:

use yii\web\UploadedFile;
$restRequestData = Yii::$app->request->getBodyParams();
$uploadedFile = UploadedFile::getInstancesByName('photo');
$model = new Item();
$model->populate($restRequestData);
copy($uploadedFile->tempName, '/path/to/file/storage/photo.jpg');

Note: although this parser fully emulates regular structure of the $_FILES, related temporary files, which are available via tmp_name key, will not be recognized by PHP as uploaded ones. Thus functions like is_uploaded_file() and move_uploaded_file() will fail on them.

PropertyTypeDescriptionDefined by
$forceboolWhether to parse raw body even for ‘POST’ request and $_FILES already populated. Default: false. Available since 2.0.13.MultipartFormDataParser
$uploadFileMaxCountintMaximum upload files count.MultipartFormDataParser
$uploadFileMaxSizeintUpload file max size in bytes.MultipartFormDataParser
MethodDescriptionDefined by
__construct()Constructor.yii\base\BaseObject
__call()Calls the named method which is not a class method.yii\base\BaseObject
__get()Returns the value of an object property.yii\base\BaseObject
__isset()Checks if a property is set, i.e. defined and not null.yii\base\BaseObject
__set()Sets value of an object property.yii\base\BaseObject
__unset()Sets an object property to null.yii\base\BaseObject
canGetProperty()Returns a value indicating whether a property can be read.yii\base\BaseObject
canSetProperty()Returns a value indicating whether a property can be set.yii\base\BaseObject
className() staticReturns the fully qualified name of this class.yii\base\BaseObject
getUploadFileMaxCount()MultipartFormDataParser
getUploadFileMaxSize()MultipartFormDataParser
hasMethod()Returns a value indicating whether a method is defined.yii\base\BaseObject
hasProperty()Returns a value indicating whether a property is defined.yii\base\BaseObject
init()Initializes the object.yii\base\BaseObject
parse()Parses a HTTP request body.MultipartFormDataParser
setUploadFileMaxCount()MultipartFormDataParser
setUploadFileMaxSize()MultipartFormDataParser
public bool $force = false

Whether to parse raw body even for ‘POST’ request and $_FILES already populated.

By default this option is disabled saving performance for ‘POST’ requests, which are already processed by PHP automatically.

Note: if this option is enabled, value of $_FILES will be reset on each parse.

Since

2.0.13

public function getUploadFileMaxCount(): int

Returns

int: Maximum upload files count.

public function getUploadFileMaxSize(): int

Returns

int: Upload file max size in bytes.

public function parse(mixed $rawBody, mixed $contentType): mixed

Parses a HTTP request body.

Parameters

ParameterTypeDescription
$rawBodymixedThe raw HTTP request body.
$contentTypemixedThe content type specified for the request body.

Returns

mixed: Parameters parsed from the request body

public function setUploadFileMaxCount(int $uploadFileMaxCount): mixed

Parameters

ParameterTypeDescription
$uploadFileMaxCountintMaximum upload files count.

Returns

mixed

public function setUploadFileMaxSize(int $uploadFileMaxSize): mixed

Parameters

ParameterTypeDescription
$uploadFileMaxSizeintUpload file max size in bytes.

Returns

mixed